﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using movicon;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private movicon.PmeDocCmdTarget objSCADA;
        private movicon.DBVariableCmdTarget objDB;

        public Form1()
        {
            InitializeComponent();
        }

        private void btnReadValue_Click(object sender, EventArgs e)
        {
            try
            {

                objSCADA = (movicon.PmeDocCmdTarget)System.Runtime.InteropServices.Marshal.GetActiveObject("Movicon.Document.11.0");
                objDB = (movicon.DBVariableCmdTarget)objSCADA.GetRealTimeDB();

                txtVarValue.Text = objDB.GetVariableValue(txtVarName.Text).ToString();
                txtStatus.Text = "Succesfull read from movicon";

                objDB = null;
                objSCADA = null;
            }
            catch
            {
                // connecting to movicon failed
                txtStatus.Text = "Movicon not found or not running";
            }

        }

        private void button1_Click(object sender, EventArgs e)
        {
            try
            {
                objSCADA = (movicon.PmeDocCmdTarget)System.Runtime.InteropServices.Marshal.GetActiveObject("Movicon.Document.11.0");
                objDB = (movicon.DBVariableCmdTarget)objSCADA.GetRealTimeDB();

                objDB.SetVariableValue(txtVarName.Text, txtVarValue.Text);
                txtStatus.Text = "Succesfull write to movicon";

                objDB = null;
                objSCADA = null;
            }
            catch
            {
                // connecting to movicon failed
                txtStatus.Text = "Movicon not found or not running";
            }


        }
    }
}
