// Il computer ha generato classi wrapper IDispatch create con l'Aggiunta guidata classe da libreria dei tipi

// CDBVariableCmdTarget classe wrapper

class CDBVariableCmdTarget : public COleDispatchDriver
{
public:
	CDBVariableCmdTarget(){} // Chiama il costruttore predefinito COleDispatchDriver
	CDBVariableCmdTarget(LPDISPATCH pDispatch) : COleDispatchDriver(pDispatch) {}
	CDBVariableCmdTarget(const CDBVariableCmdTarget& dispatchSrc) : COleDispatchDriver(dispatchSrc) {}

	// Attributi
public:

	// Operazioni
public:


	// IDBVariableCmdTarget metodi
public:
	VARIANT GetVariableValue(LPCTSTR lpszVariableName)
	{
		VARIANT result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0x1, DISPATCH_METHOD, VT_VARIANT, (void*)&result, parms, lpszVariableName);
		return result;
	}
	BOOL SetVariableValue(LPCTSTR lpszVariableName, VARIANT vtValue)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR VTS_VARIANT ;
		InvokeHelper(0x2, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, lpszVariableName, &vtValue);
		return result;
	}
	BOOL IsFirstDBInstance()
	{
		BOOL result;
		InvokeHelper(0x3, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	BOOL IsValidVariable(LPCTSTR lpszVariableName)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0x4, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, lpszVariableName);
		return result;
	}
	long GetNumVariables()
	{
		long result;
		InvokeHelper(0x6, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetNumStructDefinitions()
	{
		long result;
		InvokeHelper(0x8, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	long GetVariableSize(LPCTSTR lpszVariableName)
	{
		long result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0x9, DISPATCH_METHOD, VT_I4, (void*)&result, parms, lpszVariableName);
		return result;
	}
	CString GetDynamicVariable(LPCTSTR lpszDynVariableName)
	{
		CString result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0xa, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, lpszDynVariableName);
		return result;
	}
	BOOL get_VariableInUse(LPCTSTR lpszVariableName)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0xb, DISPATCH_PROPERTYGET, VT_BOOL, (void*)&result, parms, lpszVariableName);
		return result;
	}
	void put_VariableInUse(LPCTSTR lpszVariableName, BOOL newValue)
	{
		static BYTE parms[] = VTS_BSTR VTS_BOOL ;
		InvokeHelper(0xb, DISPATCH_PROPERTYPUT, VT_EMPTY, NULL, parms, lpszVariableName, newValue);
	}
	CString GetVariableDescription(LPCTSTR lpszVariableName)
	{
		CString result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0xc, DISPATCH_METHOD, VT_BSTR, (void*)&result, parms, lpszVariableName);
		return result;
	}
	LPDISPATCH GetVariableObject(LPCTSTR lpszVariableName)
	{
		LPDISPATCH result;
		static BYTE parms[] = VTS_BSTR ;
		InvokeHelper(0xd, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, parms, lpszVariableName);
		return result;
	}
	CString GetXMLSettings()
	{
		CString result;
		InvokeHelper(0xe, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
		return result;
	}
	long GetNumDynTag()
	{
		long result;
		InvokeHelper(0x10, DISPATCH_METHOD, VT_I4, (void*)&result, NULL);
		return result;
	}
	BOOL PurgeDynTag()
	{
		BOOL result;
		InvokeHelper(0x12, DISPATCH_METHOD, VT_BOOL, (void*)&result, NULL);
		return result;
	}
	CString GetTraceDBDSNConnectionString()
	{
		CString result;
		InvokeHelper(0x2c, DISPATCH_METHOD, VT_BSTR, (void*)&result, NULL);
		return result;
	}
	BOOL GetVariableAddressInfo(LPCTSTR lpszVariableName, short * nType, short * nAreaType, long * nAddress, short * nSubAddress)
	{
		BOOL result;
		static BYTE parms[] = VTS_BSTR VTS_PI2 VTS_PI2 VTS_PI4 VTS_PI2 ;
		InvokeHelper(0x2d, DISPATCH_METHOD, VT_BOOL, (void*)&result, parms, lpszVariableName, nType, nAreaType, nAddress, nSubAddress);
		return result;
	}
	LPDISPATCH GetTraceDBADOConn()
	{
		LPDISPATCH result;
		InvokeHelper(0x2e, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, NULL);
		return result;
	}
	LPDISPATCH GetRealTimeDBADOConn()
	{
		LPDISPATCH result;
		InvokeHelper(0x2f, DISPATCH_METHOD, VT_DISPATCH, (void*)&result, NULL);
		return result;
	}

	// IDBVariableCmdTarget propriet
public:
long GetPurgeDynTagTimer()
{
	long result;
	GetProperty(0xf, VT_I4, (void*)&result);
	return result;
}
void SetPurgeDynTagTimer(long propVal)
{
	SetProperty(0xf, VT_I4, propVal);
}
BOOL GetEnableInUseVarMng()
{
	BOOL result;
	GetProperty(0x11, VT_BOOL, (void*)&result);
	return result;
}
void SetEnableInUseVarMng(BOOL propVal)
{
	SetProperty(0x11, VT_BOOL, propVal);
}
BOOL GetEnableNTSecurityOPCServerTag()
{
	BOOL result;
	GetProperty(0x13, VT_BOOL, (void*)&result);
	return result;
}
void SetEnableNTSecurityOPCServerTag(BOOL propVal)
{
	SetProperty(0x13, VT_BOOL, propVal);
}
long GetOPCServerMinImpersonationLevel()
{
	long result;
	GetProperty(0x16, VT_I4, (void*)&result);
	return result;
}
void SetOPCServerMinImpersonationLevel(long propVal)
{
	SetProperty(0x16, VT_I4, propVal);
}
long GetOPCServerShutdownClientsTimeout()
{
	long result;
	GetProperty(0x17, VT_I4, (void*)&result);
	return result;
}
void SetOPCServerShutdownClientsTimeout(long propVal)
{
	SetProperty(0x17, VT_I4, propVal);
}
BOOL GetOPCServerEnableAEAck()
{
	BOOL result;
	GetProperty(0x19, VT_BOOL, (void*)&result);
	return result;
}
void SetOPCServerEnableAEAck(BOOL propVal)
{
	SetProperty(0x19, VT_BOOL, propVal);
}
BOOL GetUseSharedDynTag()
{
	BOOL result;
	GetProperty(0x1a, VT_BOOL, (void*)&result);
	return result;
}
void SetUseSharedDynTag(BOOL propVal)
{
	SetProperty(0x1a, VT_BOOL, propVal);
}
BOOL GetTraceDBRecycleDBConnection()
{
	BOOL result;
	GetProperty(0x1b, VT_BOOL, (void*)&result);
	return result;
}
void SetTraceDBRecycleDBConnection(BOOL propVal)
{
	SetProperty(0x1b, VT_BOOL, propVal);
}
BOOL GetTraceDBSendAdministrativeAlert()
{
	BOOL result;
	GetProperty(0x1c, VT_BOOL, (void*)&result);
	return result;
}
void SetTraceDBSendAdministrativeAlert(BOOL propVal)
{
	SetProperty(0x1c, VT_BOOL, propVal);
}
long GetTraceDBMaxError()
{
	long result;
	GetProperty(0x1d, VT_I4, (void*)&result);
	return result;
}
void SetTraceDBMaxError(long propVal)
{
	SetProperty(0x1d, VT_I4, propVal);
}
long GetTraceDBMaxNumberTrans()
{
	long result;
	GetProperty(0x1e, VT_I4, (void*)&result);
	return result;
}
void SetTraceDBMaxNumberTrans(long propVal)
{
	SetProperty(0x1e, VT_I4, propVal);
}
long GetTraceDBMaxCacheBeforeFlush()
{
	long result;
	GetProperty(0x1f, VT_I4, (void*)&result);
	return result;
}
void SetTraceDBMaxCacheBeforeFlush(long propVal)
{
	SetProperty(0x1f, VT_I4, propVal);
}
CString GetTraceDBDsn()
{
	CString result;
	GetProperty(0x20, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBDsn(CString propVal)
{
	SetProperty(0x20, VT_BSTR, propVal);
}
CString GetTraceDBUser()
{
	CString result;
	GetProperty(0x21, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBUser(CString propVal)
{
	SetProperty(0x21, VT_BSTR, propVal);
}
CString GetTraceDBTimeColName()
{
	CString result;
	GetProperty(0x22, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBTimeColName(CString propVal)
{
	SetProperty(0x22, VT_BSTR, propVal);
}
CString GetTraceDBLocalTimeColName()
{
	CString result;
	GetProperty(0x23, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBLocalTimeColName(CString propVal)
{
	SetProperty(0x23, VT_BSTR, propVal);
}
CString GetTraceDBMSecColName()
{
	CString result;
	GetProperty(0x24, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBMSecColName(CString propVal)
{
	SetProperty(0x24, VT_BSTR, propVal);
}
CString GetTraceDBUserColName()
{
	CString result;
	GetProperty(0x25, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBUserColName(CString propVal)
{
	SetProperty(0x25, VT_BSTR, propVal);
}
CString GetTraceDBChangerColName()
{
	CString result;
	GetProperty(0x26, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBChangerColName(CString propVal)
{
	SetProperty(0x26, VT_BSTR, propVal);
}
CString GetTraceDBValueBeforeColName()
{
	CString result;
	GetProperty(0x27, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBValueBeforeColName(CString propVal)
{
	SetProperty(0x27, VT_BSTR, propVal);
}
CString GetTraceDBValueAfterColName()
{
	CString result;
	GetProperty(0x28, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBValueAfterColName(CString propVal)
{
	SetProperty(0x28, VT_BSTR, propVal);
}
CString GetTraceDBValueColName()
{
	CString result;
	GetProperty(0x29, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBValueColName(CString propVal)
{
	SetProperty(0x29, VT_BSTR, propVal);
}
CString GetTraceDBQualityColName()
{
	CString result;
	GetProperty(0x2a, VT_BSTR, (void*)&result);
	return result;
}
void SetTraceDBQualityColName(CString propVal)
{
	SetProperty(0x2a, VT_BSTR, propVal);
}
long GetTraceDBDefVarCharPrecision()
{
	long result;
	GetProperty(0x2b, VT_I4, (void*)&result);
	return result;
}
void SetTraceDBDefVarCharPrecision(long propVal)
{
	SetProperty(0x2b, VT_I4, propVal);
}

};
