// ROT_VisualCDlg.cpp : file di implementazione
//

#include "stdafx.h"
#include "ROT_VisualC.h"
#include "ROT_VisualCDlg.h"
#include ".\rot_visualcdlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// finestra di dialogo CAboutDlg utilizzata per visualizzare le informazioni sull'applicazione.

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dati della finestra di dialogo
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // supporto DDX/DDV

// Implementazione
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// finestra di dialogo CROT_VisualCDlg



CROT_VisualCDlg::CROT_VisualCDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CROT_VisualCDlg::IDD, pParent)
	, m_szVAR00001(_T(""))
	, m_szVAR00002(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CROT_VisualCDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT2, m_szVAR00001);
	DDX_Text(pDX, IDC_EDIT3, m_szVAR00002);
}

static const IID IID_IDispatcher =
{ 0xBD63E682, 0x1B76, 0x4DDD, { 0xA9, 0xF6, 0x57, 0xF3, 0xB7, 0xEE, 0x05,
0x66 } };

static LPCTSTR lpszDispatcher = _T("movicon.exe");

static LPTSTR lpszClassIDMovX1 = _T("Movicon.Document.10.1");
static LPTSTR lpszClassIDMovX2 = _T("Movicon.Document.10.2");
static LPTSTR lpszClassIDMov11 = _T("Movicon.Document.11.0");

BOOL CROT_VisualCDlg::GetActiveObject()
{
	USES_CONVERSION;

	LPUNKNOWN lpUnknown;
	HRESULT hRes;
	bool bOk = false;
	// Recupero il riferimento al CLSID di Movicon
	CLSID clsid;
	HRESULT hr = ::CLSIDFromString(T2OLE(lpszClassIDMovX1), &clsid);
	if(SUCCEEDED(hr))
	{
		// Recupero il riferimento di Movicon registrato nella ROT
		hRes = ::GetActiveObject(clsid, NULL, &lpUnknown);
		if (SUCCEEDED(hRes))
			bOk = true;
	}

	if(!bOk)
	{
		hr = ::CLSIDFromString(T2OLE(lpszClassIDMovX2), &clsid);
		if(SUCCEEDED(hr))
		{
			// Recupero il riferimento di Movicon registrato nella ROT
			hRes = ::GetActiveObject(clsid, NULL, &lpUnknown);
			if (SUCCEEDED(hRes))
				bOk = true;
		}
	}

	if(!bOk)
	{
		hr = ::CLSIDFromString(T2OLE(lpszClassIDMov11), &clsid);
		if(SUCCEEDED(hr))
		{
			// Recupero il riferimento di Movicon registrato nella ROT
			hRes = ::GetActiveObject(clsid, NULL, &lpUnknown);
			if (FAILED(hRes))
				return FALSE;
		}
		else
			return FALSE;
	}

	// Collego il riferimento di Movicon alla mia classe
	LPDISPATCH lpDispatch;
	hRes = lpUnknown->QueryInterface(IID_IDispatch,
		(void**)&lpDispatch);
	lpUnknown->Release();
	SUCCEEDED(hRes);
	if (SUCCEEDED(hRes))
	{
		PmeDocCmdTarget.AttachDispatch(lpDispatch);
		m_bLoaded = TRUE;

	}

	return SUCCEEDED(hRes);

	/*
    USES_CONVERSION;

	// Recupero il riferimento al CLSID di Movicon
    CLSID clsid;
    HRESULT hr = ::CLSIDFromString(T2OLE(lpszClassIDMovX1), &clsid);
    SUCCEEDED(hr);
    if (FAILED(hr))
	{
		HRESULT hr = ::CLSIDFromString(T2OLE(lpszClassIDMovX2), &clsid);
		SUCCEEDED(hr);
		if (FAILED(hr))
		{
			HRESULT hr = ::CLSIDFromString(T2OLE(lpszClassIDMov11), &clsid);
			SUCCEEDED(hr);
			if (FAILED(hr))
				return FALSE;
		}
	        
	}
	// Recupero il riferimento di Movicon registrato nella ROT
    LPUNKNOWN lpUnknown;
    HRESULT hRes = ::GetActiveObject(clsid, NULL, &lpUnknown);
    
    SUCCEEDED(hRes);
    if (FAILED(hRes))
        return FALSE;

	// Collego il riferimento di Movicon alla mia classe
    LPDISPATCH lpDispatch;
    hRes = lpUnknown->QueryInterface(IID_IDispatch,
        (void**)&lpDispatch);
    lpUnknown->Release();
    SUCCEEDED(hRes);
    if (SUCCEEDED(hRes))
    {
        PmeDocCmdTarget.AttachDispatch(lpDispatch);
		m_bLoaded = TRUE;
        
    }

    return SUCCEEDED(hRes);*/
}

BEGIN_MESSAGE_MAP(CROT_VisualCDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
END_MESSAGE_MAP()


// gestori di messaggi di CROT_VisualCDlg

BOOL CROT_VisualCDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Aggiungere la voce di menu "Informazioni su..." al menu di sistema.

	// IDM_ABOUTBOX deve trovarsi tra i comandi di sistema.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Impostare l'icona per questa finestra di dialogo. Il framework non esegue questa operazione automaticamente
	//  se la finestra principale dell'applicazione non  una finestra di dialogo.
	SetIcon(m_hIcon, TRUE);			// Impostare icona grande.
	SetIcon(m_hIcon, FALSE);		// Impostare icona piccola.

	// Inzializzo le mie variabili interne

	m_szVAR00001 = _T("0");
	m_szVAR00002 = _T("0");
	
	m_bLoaded = FALSE;

	// Recupero il riferimento a Movicon

	LPDISPATCH lpDispatch;

	if (!GetActiveObject()){
		AfxMessageBox(_T("Unable to find Movicon! Check if it's running."));
		return TRUE;
	}

	// Recupero il valore delle variabili dal progetto

	lpDispatch = PmeDocCmdTarget.GetRealTimeDB();
	DBVariableCmdTarget.AttachDispatch(lpDispatch);

	m_szVAR00001 = DBVariableCmdTarget.GetVariableValue("VAR00001");
	m_szVAR00002 = DBVariableCmdTarget.GetVariableValue("VAR00002");

	UpdateData(FALSE);
	
	return TRUE;  // restituisce TRUE a meno che non venga impostato lo stato attivo su un controllo.
}


void CROT_VisualCDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// Se si aggiunge alla finestra di dialogo un pulsante di riduzione a icona, per trascinare l'icona sar necessario
//  il codice sottostante. Per le applicazioni MFC che utilizzano il modello documento/vista,
//  questa operazione viene eseguita automaticamente dal framework.

void CROT_VisualCDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // contesto di periferica per il disegno

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Centrare l'icona nel rettangolo client.
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Disegnare l'icona
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Il sistema chiama questa funzione per ottenere la visualizzazione del cursore durante il trascinamento
//  della finestra ridotta a icona.
HCURSOR CROT_VisualCDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CROT_VisualCDlg::OnBnClickedButton1()
{

	LPDISPATCH lpDispatch;
	BOOL bRet;
	VARIANT vntValue;

	if (!m_bLoaded)
	{
		if (!GetActiveObject()){
			AfxMessageBox(_T("Unable to find Movicon! Check if it's running."));
			return;
		}
		//Recupero il riferimento al RealTimeDB
		lpDispatch = PmeDocCmdTarget.GetRealTimeDB();
		DBVariableCmdTarget.AttachDispatch(lpDispatch);
	}

	UpdateData();
	
	// Dichiaro la variabile VARIANT come integer
	vntValue.vt = VT_I4;

	// Assegno al VARIANT l'intero, facendo un cast dalla variabile interna di tipo stringa
	vntValue.intVal = atoi(m_szVAR00001);

	// Chiamo la SetVariableValue
	bRet = DBVariableCmdTarget.SetVariableValue("VAR00001", vntValue);

	// Stessa cosa per la seconda variabile
	vntValue.vt = VT_I4;
	vntValue.intVal = atoi(m_szVAR00002);
	bRet = DBVariableCmdTarget.SetVariableValue("VAR00002", vntValue);

}


