// ROT_VisualCDlg.h : file di intestazione
//

#pragma once
#include "CPmeDocCmdTarget.h"
#include "CDBVariableCmdTarget.h"


// finestra di dialogo CROT_VisualCDlg
class CROT_VisualCDlg : public CDialog
{
// Costruzione
public:
	CROT_VisualCDlg(CWnd* pParent = NULL);	// costruttore standard

// Dati della finestra di dialogo
	enum { IDD = IDD_ROT_VISUALC_DIALOG };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// supporto DDX/DDV


// Implementazione
protected:
	HICON m_hIcon;

	// Funzioni generate per la mappa dei messaggi
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	DECLARE_MESSAGE_MAP()
public:
	BOOL GetActiveObject(); // Metodo per recuperare l'interfaccia di Movicon registrata nella ROT
	CPmeDocCmdTarget PmeDocCmdTarget; // Classe wrapper per l'interfaccia della PmeDocCmdTarget (Vedi help di Movicon)
	CDBVariableCmdTarget DBVariableCmdTarget; // Classe wrapper per l'interfaccia della DBVariableCmdTarget (Vedi help di Movicon)

	BOOL m_bLoaded; // Variabile interna che mi indica lo stato dell'oggetto PmeDocCmdTarget
	CString m_szVAR00001; // Variabile interna di tipo stringa contenente il valore della variabile VAR00001 di Movicon
	CString m_szVAR00002; // Variabile interna di tipo stringa contenente il valore della variabile VAR00002 di Movicon
	afx_msg void OnBnClickedButton1();
};
